Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs	(revision 13469)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs	(revision 13470)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -35,4 +36,6 @@
   public abstract class ProbabilisticTravelingSalesmanProblem : SingleObjectiveBasicProblem<PermutationEncoding>,
   IProblemInstanceConsumer<PTSPData> {
+    protected bool SuppressEvents { get; set; }
+
     private static readonly int DistanceMatrixSizeLimit = 1000;
 
@@ -92,5 +95,8 @@
     [StorableConstructor]
     protected ProbabilisticTravelingSalesmanProblem(bool deserializing) : base(deserializing) { }
-    protected ProbabilisticTravelingSalesmanProblem(ProbabilisticTravelingSalesmanProblem original, Cloner cloner) : base(original, cloner) { }
+    protected ProbabilisticTravelingSalesmanProblem(ProbabilisticTravelingSalesmanProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
     protected ProbabilisticTravelingSalesmanProblem() {
       Parameters.Add(new OptionalValueParameter<DoubleMatrix>("Coordinates", "The x- and y-Coordinates of the cities."));
@@ -101,5 +107,5 @@
       Parameters.Add(new ValueParameter<DoubleArray>("Probabilities", "This list describes for each city the probability of appearing in a realized instance."));
 
-      Coordinates = new DoubleMatrix(new double[,] {
+      var coordinates = new DoubleMatrix(new double[,] {
         { 100, 100 }, { 100, 200 }, { 100, 300 }, { 100, 400 },
         { 200, 100 }, { 200, 200 }, { 200, 300 }, { 200, 400 },
@@ -107,6 +113,50 @@
         { 400, 100 }, { 400, 200 }, { 400, 300 }, { 400, 400 }
       });
-
-      Probabilities = new DoubleArray(new double[] { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 });
+      Coordinates = coordinates;
+      Encoding.Length = coordinates.Rows;
+      DistanceCalculator = new EuclideanDistance();
+      DistanceMatrix = new DistanceMatrix(CalculateDistances());
+      Probabilities = new DoubleArray(Enumerable.Range(0, coordinates.Rows).Select(x => 0.5).ToArray());
+
+      RegisterEventHandlers();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+
+    private void RegisterEventHandlers() {
+      CoordinatesParameter.ValueChanged += CoordinatesParameterOnValueChanged;
+      if (Coordinates != null) {
+        Coordinates.RowsChanged += CoordinatesOnChanged;
+        Coordinates.ItemChanged += CoordinatesOnChanged;
+      }
+      UseDistanceMatrixParameter.Value.ValueChanged += UseDistanceMatrixValueChanged;
+      DistanceCalculatorParameter.ValueChanged += DistanceCalculatorParameterOnValueChanged;
+    }
+
+    private void CoordinatesParameterOnValueChanged(object sender, EventArgs eventArgs) {
+      if (Coordinates != null) {
+        Coordinates.RowsChanged += CoordinatesOnChanged;
+        Coordinates.ItemChanged += CoordinatesOnChanged;
+      }
+      if (SuppressEvents) return;
+      UpdateInstance();
+    }
+
+    private void CoordinatesOnChanged(object sender, EventArgs eventArgs) {
+      if (SuppressEvents) return;
+      UpdateInstance();
+    }
+
+    private void UseDistanceMatrixValueChanged(object sender, EventArgs eventArgs) {
+      if (SuppressEvents) return;
+      UpdateInstance();
+    }
+
+    private void DistanceCalculatorParameterOnValueChanged(object sender, EventArgs eventArgs) {
+      if (SuppressEvents) return;
+      UpdateInstance();
     }
 
@@ -117,41 +167,72 @@
     public abstract double Evaluate(Permutation tour, IRandom random);
 
+    public double[,] CalculateDistances() {
+      var coords = Coordinates;
+      var len = coords.Rows;
+      var dist = DistanceCalculator;
+
+      var matrix = new double[len, len];
+      for (var i = 0; i < len - 1; i++)
+        for (var j = i + 1; j < len; j++)
+          matrix[i, j] = matrix[j, i] = dist.Calculate(i, j, coords);
+
+      return matrix;
+    }
+
     public virtual void Load(PTSPData data) {
-      if (data.Coordinates == null && data.Distances == null)
-        throw new System.IO.InvalidDataException("The given instance specifies neither coordinates nor distances!");
-      if (data.Dimension > DistanceMatrixSizeLimit && (data.Coordinates == null || data.Coordinates.GetLength(0) != data.Dimension || data.Coordinates.GetLength(1) != 2))
-        throw new System.IO.InvalidDataException("The given instance is too large for using a distance matrix and there is a problem with the coordinates.");
-      if (data.Coordinates != null && (data.Coordinates.GetLength(0) != data.Dimension || data.Coordinates.GetLength(1) != 2))
-        throw new System.IO.InvalidDataException("The coordinates of the given instance are not in the right format, there need to be one row for each customer and two columns for the x and y coordinates respectively.");
-
-      switch (data.DistanceMeasure) {
-        case DistanceMeasure.Direct:
-          DistanceCalculator = null;
-          if (data.Dimension > DistanceMatrixSizeLimit && Coordinates != null) {
-            DistanceCalculator = new EuclideanDistance();
-            UseDistanceMatrix = false;
-          } else UseDistanceMatrix = true;
-          break;
-        case DistanceMeasure.Att: DistanceCalculator = new AttDistance(); break;
-        case DistanceMeasure.Euclidean: DistanceCalculator = new EuclideanDistance(); break;
-        case DistanceMeasure.Geo: DistanceCalculator = new GeoDistance(); break;
-        case DistanceMeasure.Manhattan: DistanceCalculator = new ManhattanDistance(); break;
-        case DistanceMeasure.Maximum: DistanceCalculator = new MaximumDistance(); break;
-        case DistanceMeasure.RoundedEuclidean: DistanceCalculator = new RoundedEuclideanDistance(); break;
-        case DistanceMeasure.UpperEuclidean: DistanceCalculator = new UpperEuclideanDistance(); break;
-        default: throw new ArgumentException("Distance measure is unknown");
-      }
-
-      Name = data.Name;
-      Description = data.Description;
-
-      Probabilities = new DoubleArray(data.Probabilities);
-      BestKnownSolution = data.BestKnownTour != null ? new Permutation(PermutationTypes.RelativeUndirected, data.BestKnownTour) : null;
-      Coordinates = data.Coordinates != null && data.Coordinates.GetLength(0) > 0 ? new DoubleMatrix(data.Coordinates) : null;
-      DistanceMatrix = new DistanceMatrix(data.GetDistanceMatrix());
-
-      Encoding.Length = data.Dimension;
-
+      try {
+        SuppressEvents = true;
+        if (data.Coordinates == null && data.Distances == null)
+          throw new System.IO.InvalidDataException("The given instance specifies neither coordinates nor distances!");
+        if (data.Dimension > DistanceMatrixSizeLimit && (data.Coordinates == null || data.Coordinates.GetLength(0) != data.Dimension || data.Coordinates.GetLength(1) != 2))
+          throw new System.IO.InvalidDataException("The given instance is too large for using a distance matrix and there is a problem with the coordinates.");
+        if (data.Coordinates != null && (data.Coordinates.GetLength(0) != data.Dimension || data.Coordinates.GetLength(1) != 2))
+          throw new System.IO.InvalidDataException("The coordinates of the given instance are not in the right format, there need to be one row for each customer and two columns for the x and y coordinates respectively.");
+
+        switch (data.DistanceMeasure) {
+          case DistanceMeasure.Direct:
+            DistanceCalculator = null;
+            if (data.Dimension > DistanceMatrixSizeLimit && Coordinates != null) {
+              DistanceCalculator = new EuclideanDistance();
+              UseDistanceMatrix = false;
+            } else UseDistanceMatrix = true;
+            break;
+          case DistanceMeasure.Att: DistanceCalculator = new AttDistance(); break;
+          case DistanceMeasure.Euclidean: DistanceCalculator = new EuclideanDistance(); break;
+          case DistanceMeasure.Geo: DistanceCalculator = new GeoDistance(); break;
+          case DistanceMeasure.Manhattan: DistanceCalculator = new ManhattanDistance(); break;
+          case DistanceMeasure.Maximum: DistanceCalculator = new MaximumDistance(); break;
+          case DistanceMeasure.RoundedEuclidean: DistanceCalculator = new RoundedEuclideanDistance(); break;
+          case DistanceMeasure.UpperEuclidean: DistanceCalculator = new UpperEuclideanDistance(); break;
+          default: throw new ArgumentException("Distance measure is unknown");
+        }
+
+        Name = data.Name;
+        Description = data.Description;
+
+        Probabilities = new DoubleArray(data.Probabilities);
+        BestKnownSolution = data.BestKnownTour != null ? new Permutation(PermutationTypes.RelativeUndirected, data.BestKnownTour) : null;
+        Coordinates = data.Coordinates != null && data.Coordinates.GetLength(0) > 0 ? new DoubleMatrix(data.Coordinates) : null;
+        DistanceMatrix = data.Dimension <= DistanceMatrixSizeLimit && UseDistanceMatrix ? new DistanceMatrix(data.GetDistanceMatrix()) : null;
+
+        Encoding.Length = data.Dimension;
+      } finally { SuppressEvents = false; }
       OnReset();
+    }
+
+    private void UpdateInstance() {
+      var len = GetProblemDimension();
+      if (Coordinates != null && Coordinates.Rows <= DistanceMatrixSizeLimit
+        && DistanceCalculator != null && UseDistanceMatrix)
+        DistanceMatrix = new DistanceMatrix(CalculateDistances());
+      if (!UseDistanceMatrix) DistanceMatrix = null;
+      Encoding.Length = len;
+
+      OnReset();
+    }
+
+    private int GetProblemDimension() {
+      if (Coordinates == null && DistanceMatrix == null) throw new InvalidOperationException("Both coordinates and distance matrix are null, please specify at least one of them.");
+      return Coordinates != null ? Coordinates.Rows : DistanceMatrix.Rows;
     }
   }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Properties/AssemblyInfo.cs.frame	(revision 13469)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Properties/AssemblyInfo.cs.frame	(revision 13470)
@@ -34,3 +34,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.11.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.13.$WCREV$")]
Index: /branches/PTSP/PTSP.sln
===================================================================
--- /branches/PTSP/PTSP.sln	(revision 13469)
+++ /branches/PTSP/PTSP.sln	(revision 13470)
@@ -26,26 +26,38 @@
 		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x64.ActiveCfg = Debug|x64
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x64.Build.0 = Debug|x64
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x86.ActiveCfg = Debug|x86
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Debug|x86.Build.0 = Debug|x86
 		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|Any CPU.Build.0 = Release|Any CPU
-		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x64.ActiveCfg = Release|Any CPU
-		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x86.ActiveCfg = Release|Any CPU
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x64.ActiveCfg = Release|x64
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x64.Build.0 = Release|x64
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x86.ActiveCfg = Release|x86
+		{97198965-AFEA-496B-B3B1-316905C43FD6}.Release|x86.Build.0 = Release|x86
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x64.ActiveCfg = Debug|x64
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x64.Build.0 = Debug|x64
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x86.ActiveCfg = Debug|x86
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Debug|x86.Build.0 = Debug|x86
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|Any CPU.Build.0 = Release|Any CPU
-		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x64.ActiveCfg = Release|Any CPU
-		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x86.ActiveCfg = Release|Any CPU
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x64.ActiveCfg = Release|x64
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x64.Build.0 = Release|x64
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x86.ActiveCfg = Release|x86
+		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x86.Build.0 = Release|x86
 		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x64.ActiveCfg = Debug|x64
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x64.Build.0 = Debug|x64
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x86.ActiveCfg = Debug|x86
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Debug|x86.Build.0 = Debug|x86
 		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|Any CPU.Build.0 = Release|Any CPU
-		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x64.ActiveCfg = Release|Any CPU
-		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x86.ActiveCfg = Release|Any CPU
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x64.ActiveCfg = Release|x64
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x64.Build.0 = Release|x64
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x86.ActiveCfg = Release|x86
+		{CBEC171A-F7EC-460D-94E2-D58625811D99}.Release|x86.Build.0 = Release|x86
 		{CE0F99D6-1C56-48A9-9B68-3E5B833703EF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{CE0F99D6-1C56-48A9-9B68-3E5B833703EF}.Debug|Any CPU.Build.0 = Debug|Any CPU
